import { EntityFireImmuneComponent, ItemCompleteChargeEvent, world, WorldInitializeEvent, Location, BlockLocation, TickEvent, ScoreboardIdentity, system } from "@minecraft/server"
import { ActionFormData, MessageFormData, ModalFormData, ActionFormResponse, MessageFormResponse, ModalFormResponse } from "@minecraft/server-ui"
import * as GameTest from "@minecraft/server-gametest";
var currentSec = 0
var mapUsedCount = 0
var p = world.getDimension("overworld")
var goal_x_new, goal_z_new
var MAX_RANGE = 300000
var signalRed = false, signalBlue = false, signalYellow = false, signalGreen = false
function menuCall(player){
    var player_x, player_y, player_z, player_name = player.nameTag, player_d
    var player_dimension = player.dimension.id
    var menu = new ModalFormData()
        .title("Bingo helper")
        .dropdown("Options", ["Tp to teammates", "Force stop(creative needed)"])

    var updateMenu = new ModalFormData()
        .title("地图更新操作")
        .dropdown("只有在主世界才可以使用该功能",["传送至地图更新区域", "获取上一次死亡坐标", "返回传送前位置"])

      
    var stopMenu = new MessageFormData()
        .title("Force stop game")
        .body("Admin only(or creative)")
        .button1("confirm")
        .button2("cancel")
    
    var lookupMenu = new ModalFormData()
        .title("查询物品")
        .slider("所查询物品的行数",1,5,1,1)
        .slider("所查询物品的列数",1,5,1,1)
        
    menu.show(player).then((afmenu) => {
        mapUsedCount = 0
        // p.runCommandAsync("say " + afmenu.formValues[1])
        // if(afmenu.formValues[0] == 0 && player_dimension == "minecraft:overworld"){
        //     updateMenu.show(player).then((afmap) =>{
        //         if(afmap.formValues[0] == 0 && ((player.location.x < 0 || player.location.x > 300)) && (player.location.z < -100 || player.location.z > 100)){
        //             player.runCommandAsync("scoreboard players set @s mapx " + Math.round(player.location.x))
        //             player.runCommandAsync("scoreboard players set @s mapy " + Math.round(player.location.y))
        //             player.runCommandAsync("scoreboard players set @s mapz " + Math.round(player.location.z))
        //             // if(player_dimension == "minecraft:overworld") p.runCommandAsync("scoreboard players set @s dimension 0")
        //             // if(player_dimension == "minecraft:the_nether") p.runCommandAsync("scoreboard players set @s dimension 1")
        //             // if(player_dimension == "minecraft:the_end") p.runCommandAsync("scoreboard players set @s dimension 2")
        //             player.runCommandAsync("gamemode a")
        //             player.runCommandAsync("effect @s weakness 30000 100 true")
        //             player.runCommandAsync("tp @s 256 177 0 -90 0")
        //         }
        //         else if(afmap.formValues[0] == 1){
        //             let playersX = world.scoreboard.getObjective("mapx").getParticipants()
        //             let playersY = world.scoreboard.getObjective("mapy").getParticipants()
        //             let playersZ = world.scoreboard.getObjective("mapz").getParticipants()
        //             // let playersD = world.scoreboard.getObjective("dimension").getParticipants()
        //             // player.runCommandAsync("say " + player_name + " " + playersX[0].displayName)
        //             for(var i = 0; i < playersX.length; i++) {
        //                 if(playersX[i].displayName == player_name){
        //                     player_x = world.scoreboard.getObjective("mapx").getScore(playersX[i])
        //                 }
        //             }
        //             for(var i = 0; i < playersY.length; i++) {
        //                 if(playersY[i].displayName == player_name){
        //                     player_y = world.scoreboard.getObjective("mapy").getScore(playersY[i])
        //                 }
        //             }
        //             for(var i = 0; i < playersZ.length; i++) {
        //                 if(playersZ[i].displayName == player_name){
        //                     player_z = world.scoreboard.getObjective("mapz").getScore(playersZ[i])
        //                 }
        //             }
        //             // for(var i = 0; i < playersD.length; i++){
        //             //     if(playersD[i].displayName == player_name){
        //             //         player_d = world.scoreboard.getObjective("dimension").getScore(playersD[i])
        //             //     }
        //             // }
        //             if(player_y <= 256){
        //                 // if(player_d == 0){
        //                 //     player.runCommandAsync("execute in overworld run tp " + player_x + " " + player_y + " " + player_z)
        //                 // }
        //                 // else if(player_d == 1){
        //                 //     player.runCommandAsync("execute in the_nether run tp " + player_x + " " + player_y + " " + player_z)
        //                 // }
        //                 // else if(player_d == 2){
        //                 //     player.runCommandAsync("execute in the_end run tp " + player_x + " " + player_y + " " + player_z)
        //                 // }
        //                 player.runCommandAsync("tp " + player_x + " " + player_y + " " + player_z)
        //             }
        //             player.runCommandAsync("scoreboard players set @s mapy 10000")
        //             player.runCommandAsync("gamemode s")
        //             player.runCommandAsync("effect @s weakness 1 101 true")
        //         }
        //     })
        // }
        if(afmenu.formValues[0] == 0){
                    var players = Array.from(world.getPlayers())
                    var teammates = new Array()
                    if(player.hasTag("green")){
                        for(var i = 0; i < players.length; i++){
                            if(players[i].hasTag("green")){
                                teammates.push(players[i].nameTag)
                            }
                        }
                    }
                    if(player.hasTag("yellow")){
                        for(var i = 0; i < players.length; i++){
                            if(players[i].hasTag("yellow")){
                                teammates.push(players[i].nameTag)
                            }
                        }
                    }
                    if(player.hasTag("blue")){
                        for(var i = 0; i < players.length; i++){
                            if(players[i].hasTag("blue")){
                                teammates.push(players[i].nameTag)
                            }
                        }
                    }
                    if(player.hasTag("red")){
                        for(var i = 0; i < players.length; i++){
                            if(players[i].hasTag("red")){
                                teammates.push(players[i].nameTag)
                            }
                        }
                    }
                    var tpMenu = new ModalFormData()
                        .title("Teleport menu")
                        .dropdown("Teammates", teammates)
                    tpMenu.show(player).then((aftp) =>{
                        var teammate_name = teammates[aftp.formValues[0]]
                        player.runCommandAsync("tp " + teammate_name)
                        p.runCommandAsync("tellraw " + player_name + " { \"rawtext\" : [ { \"text\" : \"§bDone\"}]}")
                        p.runCommandAsync("tellraw " + teammate_name + " { \"rawtext\" : [ { \"text\" : \"§b" + player_name + " has teleported to you\"}]}")
                    })
        }
        else if(afmenu.formValues[0] == 1){
            if(player.hasTag("owner")){
                stopMenu.show(player).then((afstop) => {
                    if(afstop.selection == 1){
                        p.runCommandAsync("execute " + player_name + " ~ ~ ~ say §4 has ended the game")
                        p.runCommandAsync("function activatekill")
                    }
                })
            }
        }
        // else if(afmenu.formValues[0] == 3){
        //     if(player.isOp()){
        
        //     }
        // }
    })
}

function adminMenu(player){
    mapUsedCount = 0
    var rangeMenu = new ModalFormData()
        .title("设置最大传送范围")
        .textField("填写最远能传送到的x、z坐标值的两倍","填写最远能传送到的x、z坐标值的两倍", "")

    rangeMenu.show(player).then((afrg) =>{
        if(Number(afrg.formValues[0]) != NaN){
            MAX_RANGE = Number(afrg.formValues[0])
        }
    })

}
function preMenu(player){
    var preMenu = new MessageFormData()
        .title("Choose your spawnpoint before start")
        .body("Confirm your spawnpoint or not, you have at most 3 chances to choose it.")
        .button1("Confirm spawnpoint")
        .button2("Change spawnpoint")
    // var respawnMenu = new MessageFormData()
    //     .title("")
    //     .body("重新随机出生地,如果当前不是海洋建议不要选择,勿贪")
    //     .button1("确定")
    //     .button2("取消")
    
    preMenu.show(player).then((a) =>{
        if(a.selection == 1){
            if(!player.hasTag("confirmed") && !player.hasTag("confirmed2")){
                player.addTag("confirmed")
                if(player.hasTag("red")){
                    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§eTeam red have confirmed their spawnpoint\"}]}")
                }
                if(player.hasTag("blue")){
                    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§eTeam blue have confirmed their spawnpoint\"}]}")
                }
                if(player.hasTag("yellow")){
                    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§eTeam yellow have confirmed their spawnpoint\"}]}")
                }
                if(player.hasTag("green")){
                    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§eTeam green have confirmed their spawnpoint\"}]}")
                }
            }
        }
        else if(a.selection == 0){
            if(!player.hasTag("confirmed") && !player.hasTag("confirmed2")){
                        if(player.hasTag("red")){
                            p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4Team red chose to change their spawnpoint\"}]}")
                            player.addTag("uncRed")
                            player.addTag("confirmed2")
                        }
                        if(player.hasTag("blue")){
                            p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4Team blue chose to change their spawnpoint\"}]}")
                            player.addTag("uncBlue")
                            player.addTag("confirmed2")
                        }
                        if(player.hasTag("yellow")){
                            p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4Team yellow chose to change their spawnpoint\"}]}")
                            player.addTag("uncYellow")
                            player.addTag("confirmed2")
                        }
                        if(player.hasTag("green")){
                            p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4Team green chose to change their spawnpoint\"}]}")
                            player.addTag("uncGreen")
                            player.addTag("confirmed2")
                        }
            }
        }
    })

}
world.events.beforeItemUseOn.subscribe(t =>{
    const player = t.source
    const item = t.item
    const location = t.blockLocation
    if(item.typeId == 'minecraft:filled_map' && mapUsedCount == 0 && (player.hasTag("playing") || player.hasTag("debug"))){
        menuCall(player)
        mapUsedCount++
    }
    else if(item.typeId == "minecraft:filled_map" && mapUsedCount == 0 && player.hasTag("jcz")){
        preMenu(player)
        mapUsedCount++
    }

    if(p.getBlock(location).typeId == "minecraft:bed"){
        t.cancel = true
        player.runCommandAsync("spawnpoint @s")
        p.runCommandAsync("tellraw " + player.nameTag + " { \"rawtext\" : [ { \"text\" : \"§bYour spawnpoint has been permanemtly changed(It won't change even if your bed is destroyed)\"}]}")
    }
    // else if(item.id == 'minecraft:filled_map' && mapUsedCount == 0 && player.hasTag("owner")){
    //     adminMenu(player)
    //     mapUsedCount++
    // }
})

world.events.beforeChat.subscribe(t =>{
    const sender = t.sender
    const msg = t.message
    if(sender.hasTag("green")){
        t.cancel = true
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§a[Green]<" + sender.name + ">:§r" + msg + "\"}]}")
    }
    else if(sender.hasTag("blue")){
        t.cancel = true
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§b[Blue]<" + sender.name + ">:§r" + msg + "\"}]}")
    }
    else if(sender.hasTag("yellow")){
        t.cancel = true
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§e[Yellow]<" + sender.name + ">:§r" + msg + "\"}]}")
    }
    else if(sender.hasTag("red")){
        t.cancel = true
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4[Red]<" + sender.name + ">:§r" + msg + "\"}]}")
    }
    if(sender.hasTag("spec")){
        if(msg.startsWith(".tp ")){
            t.cancel = true
            let spec_tp = msg.slice(4)
            if(spec_tp == "random"){
                sender.runCommandAsync("tp @r[tag=!spec,x=256,y=67,z=0,rm=400]")
            }
            else sender.runCommandAsync("tp \"" + spec_tp + "\"")
        }
        if(msg == ".exit"){
            t.cancel = true
            sender.runCommandAsync("tp @s 252 194 0 -90 0")
            sender.runCommandAsync("gamemode a")
        }
    }
})
var delay1
function gameStart1(){
    signalBlue = false, signalGreen = false, signalRed = false, signalYellow = false
    var players = Array.from(world.getPlayers())
    var totalPlayerCount = players.length, gamePlayerCount = 0, specPlayerCount = 0
    for(var i = 0; i < totalPlayerCount; i++){
        if(players[i].hasTag("green") || players[i].hasTag("blue") || players[i].hasTag("red") || players[i].hasTag("yellow")){
            gamePlayerCount++
            players[i].addTag("preplaying")
        }
    }
    specPlayerCount = totalPlayerCount - gamePlayerCount
    if(gamePlayerCount == 0){
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4No one in any teams , game won't start.\"}]}")
        return
    }
    else{
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"translate\" : \"bingo.message.clear\" } ] }")
        p.runCommandAsync("execute @p ~~~ spreadplayers 256 0 5 30 @a[tag=preplaying]")
        p.runCommandAsync("tp @a[tag=!preplaying] 252 194 0 -90 0")
        p.runCommandAsync("clear @a")
        p.runCommandAsync("gamemode a @a")
        delay1 = system.runSchedule(gameStart2, 60)
        // p.runCommandAsync("summon armor_stand delay1 256 82 -2 ")
        // p.runCommandAsync("scoreboard players set @e[type=armor_stand,name=delay1] ticker 60")
        return
    }
    
}
    var goal_x_red
    var goal_z_red
    var goal_x_blue
    var goal_z_blue
    var goal_x_yellow
    var goal_z_yellow
    var goal_x_green
    var goal_z_green
    var goal_b_red
    var goal_b_blue
    var goal_b_yellow
    var goal_b_green
var delay2
function gameStart2(){
    p.runCommandAsync("scoreboard objectives setdisplay sidebar countdown")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown -1")
    p.runCommandAsync("setblock 256 22 5 air")
    system.clearRunSchedule(delay1)
    goal_x_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_z_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_x_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_z_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_x_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_z_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_x_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    goal_z_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
    p.runCommandAsync("tickingarea add " + goal_x_red + " 0 " + goal_z_red + " " + goal_x_red + " 0 " + goal_z_red + " goalRed true")
    p.runCommandAsync("tickingarea add " + goal_x_blue + " 0 " + goal_z_blue + " " + goal_x_blue + " 0 " + goal_z_blue + " goalBlue true")
    p.runCommandAsync("tickingarea add " + goal_x_yellow + " 0 " + goal_z_yellow + " " + goal_x_yellow + " 0 " + goal_z_yellow + " goalYellow true")
    p.runCommandAsync("tickingarea add " + goal_x_green + " 0 " + goal_z_green + " " + goal_x_green + " 0 " + goal_z_green + " goalGreen true")
    p.runCommandAsync("function prestart")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown 20")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bPrepare to send all teams to their spawnpoint\"}]}")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bNow there's a chance to choose your spawn\"}]}")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bEvery team will have a decision maker\"}]}")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4The decision maker can click any block with your map§b(BingoCard)§4 to open menu to choose to change spawn or confirm spawn\"}]}")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§aWhen all teams have done their choices or cd is over, the game will start.\"}]}")
    delay2 = system.runSchedule(gameStart3, 400)
}
var delay3
function gameStart3(){
    system.clearRunSchedule(delay2)
    p.runCommandAsync("tag @a remove confirmed")
    p.runCommandAsync("tag @a remove confirmed2")
    p.runCommandAsync("execute @p[tag=red] ~ ~ ~ tag @r[tag=red] add jcz")
    p.runCommandAsync("execute @p[tag=blue] ~ ~ ~ tag @r[tag=blue] add jcz")
    p.runCommandAsync("execute @p[tag=yellow] ~ ~ ~ tag @r[tag=yellow] add jcz")
    p.runCommandAsync("execute @p[tag=green] ~ ~ ~ tag @r[tag=green] add jcz")
    p.runCommandAsync("scoreboard players set @a[tag=preplaying] frost 150")
    p.runCommandAsync("tp @a[tag=red] " + goal_x_red + " 256 " + goal_z_red)
    p.runCommandAsync("tp @a[tag=blue] " + goal_x_blue + " 256 " + goal_z_blue)
    p.runCommandAsync("tp @a[tag=yellow] " + goal_x_yellow + " 256 " + goal_z_yellow)
    p.runCommandAsync("tp @a[tag=green] " + goal_x_green + " 256 " + goal_z_green)
    p.runCommandAsync("scoreboard players set @a[tag=preplaying] setborder 60")
    // var players = Array.from(world.getPlayers())
    // var jczRed = " ", jczBlue = " ", jczYellow = " ", jczGreen = " "
    // for(var i = 0; i < players.length; i++){
    //     if(players[i].hasTag("jcz")){
    //         if(players[i].hasTag("red")) jczRed = players[i].nameTag
    //         if(players[i].hasTag("blue")) jczBlue = players[i].nameTag
    //         if(players[i].hasTag("yellow")) jczYellow = players[i].nameTag
    //         if(players[i].hasTag("green")) jczGreen = players[i].nameTag
    //     }
    // }

    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§aChoices remaining: 3. Time for the first choice: 30sec\"}]}")
    p.runCommandAsync("summon armor_stand System 256 87 -2")
    p.runCommandAsync("execute @e[name=System,c=1] ~ ~ ~ say Decision makers:@a[tag=jcz]")
    p.runCommandAsync("kill @e[name=System]")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§4The movement area is limited before gamestart.\"}]}")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown 30")
    delay3 = system.runSchedule(gameStart4, 600)
}
var delay4

function gameStart4(){
    system.clearRunSchedule(delay3)
    var players = Array.from(world.getPlayers())
    p.runCommandAsync("tickingarea remove goalRed")
    p.runCommandAsync("tickingarea remove goalBlue")
    p.runCommandAsync("tickingarea remove goalYellow")
    p.runCommandAsync("tickingarea remove goalGreen")
    for(var i = 0; i < players.length; i++){
        if(players[i].hasTag("uncRed")){
            goal_x_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_red + " 0 " + goal_z_red + " " + goal_x_red + " 0 " + goal_z_red + " goalRed true")
            signalRed = true
        }
        if(players[i].hasTag("uncBlue")){
            goal_x_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_blue + " 0 " + goal_z_blue + " " + goal_x_blue + " 0 " + goal_z_blue + " goalBlue true")
            signalBlue = true
        }
        if(players[i].hasTag("uncYellow")){
            goal_x_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_yellow + " 0 " + goal_z_yellow + " " + goal_x_yellow + " 0 " + goal_z_yellow + " goalYellow true")
            signalYellow = true
        }
        if(players[i].hasTag("uncGreen")){
            goal_x_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_green + " 0 " + goal_z_green + " " + goal_x_green + " 0 " + goal_z_green + " goalGreen true")
            signalGreen = true
        }
    }
    if(signalBlue == false && signalGreen == false && signalRed == false && signalYellow == false){
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bAll teams have confirmed spawnpoint, game will start in 10s\"}]}")
        p.runCommandAsync("scoreboard players set \"Countdown\" countdown 10")
        p.runCommandAsync("tag @a remove jcz")
        delay4 = system.runSchedule(gameStartFin, 200)
    }
    else{
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bReselecting spawnpoints for some teams, it won't take long.\"}]}")
        delay4 = system.runSchedule(gameStart5, 60)
    }
}
var delay5
function gameStart5(){
    system.clearRunSchedule(delay4)
    p.runCommandAsync("tag @a remove confirmed2")
    p.runCommandAsync("tag @a remove uncRed")
    p.runCommandAsync("tag @a remove uncBlue")
    p.runCommandAsync("tag @a remove uncYellow")
    p.runCommandAsync("tag @a remove uncGreen")
    if(signalBlue == true){
        p.runCommandAsync("tp @a[tag=blue] " + goal_x_blue + " 256 " + goal_z_blue)
        p.runCommandAsync("scoreboard players set @a[tag=blue] frost 150")
    }
    if(signalRed == true){
        p.runCommandAsync("tp @a[tag=red] " + goal_x_red + " 256 " + goal_z_red)
        p.runCommandAsync("scoreboard players set @a[tag=red] frost 150")
    }
    if(signalYellow == true){
        p.runCommandAsync("tp @a[tag=yellow] " + goal_x_yellow + " 256 " + goal_z_yellow)
        p.runCommandAsync("scoreboard players set @a[tag=yellow] frost 150")
    }
    if(signalGreen == true){
        p.runCommandAsync("tp @a[tag=green] " + goal_x_green + " 256 " + goal_z_green)
        p.runCommandAsync("scoreboard players set @a[tag=green] frost 150")
    }
    p.runCommandAsync("scoreboard players set @a[tag=preplaying] setborder 60")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§aChoices remaining:2. Time for this choice:25sec\"}]}")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown 25")
    delay5 = system.runSchedule(gameStart6, 500)
}
var delay6
function gameStart6(){
    system.clearRunSchedule(delay5)
    var players = Array.from(world.getPlayers())
    p.runCommandAsync("tickingarea remove goalRed")
    p.runCommandAsync("tickingarea remove goalBlue")
    p.runCommandAsync("tickingarea remove goalYellow")
    p.runCommandAsync("tickingarea remove goalGreen")
    signalBlue = false, signalGreen = false, signalRed = false, signalYellow = false
    for(var i = 0; i < players.length; i++){
        if(players[i].hasTag("uncRed")){
            goal_x_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_red + " 0 " + goal_z_red + " " + goal_x_red + " 0 " + goal_z_red + " goalRed true")
            signalRed = true
        }
        if(players[i].hasTag("uncBlue")){
            goal_x_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_blue + " 0 " + goal_z_blue + " " + goal_x_blue + " 0 " + goal_z_blue + " goalBlue true")
            signalBlue = true
        }
        if(players[i].hasTag("uncYellow")){
            goal_x_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_yellow + " 0 " + goal_z_yellow + " " + goal_x_yellow + " 0 " + goal_z_yellow + " goalYellow true")
            signalYellow = true
        }
        if(players[i].hasTag("uncGreen")){
            goal_x_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_green + " 0 " + goal_z_green + " " + goal_x_green + " 0 " + goal_z_green + " goalGreen true")
            signalGreen = true
        }
    }
    if(signalBlue == false && signalGreen == false && signalRed == false && signalYellow == false){
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bAll teams have confirmed spawnpoint, game will start in 10s\"}]}")
        p.runCommandAsync("scoreboard players set \"Countdown\" countdown 10")
        p.runCommandAsync("tag @a remove jcz")
        delay6 = system.runSchedule(gameStartFin, 200)
    }
    else{
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bReselecting spawnpoints for some teams, it won't take long.\"}]}")
        delay6 = system.runSchedule(gameStart7, 60)
    }
}
var delay7
function gameStart7(){
    system.clearRunSchedule(delay6)
    p.runCommandAsync("tag @a remove confirmed2")
    p.runCommandAsync("tag @a remove uncRed")
    p.runCommandAsync("tag @a remove uncBlue")
    p.runCommandAsync("tag @a remove uncYellow")
    p.runCommandAsync("tag @a remove uncGreen")
    if(signalBlue == true){
        p.runCommandAsync("tp @a[tag=blue] " + goal_x_blue + " 256 " + goal_z_blue)
        p.runCommandAsync("scoreboard players set @a[tag=blue] frost 150")
    }
    if(signalRed == true){
        p.runCommandAsync("tp @a[tag=red] " + goal_x_red + " 256 " + goal_z_red)
        p.runCommandAsync("scoreboard players set @a[tag=red] frost 150")
    }
    if(signalYellow == true){
        p.runCommandAsync("tp @a[tag=yellow] " + goal_x_yellow + " 256 " + goal_z_yellow)
        p.runCommandAsync("scoreboard players set @a[tag=yellow] frost 150")
    }
    if(signalGreen == true){
        p.runCommandAsync("tp @a[tag=green] " + goal_x_green + " 256 " + goal_z_green)
        p.runCommandAsync("scoreboard players set @a[tag=green] frost 150")
    }
    p.runCommandAsync("scoreboard players set @a[tag=preplaying] setborder 60")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§aChoices remaining:1. Time for this choice:25sec\"}]}")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown 25")
    delay7 = system.runSchedule(gameStart8, 500)
}
var delay8
function gameStart8(){
    system.clearRunSchedule(delay7)
    p.runCommandAsync("tickingarea remove goalRed")
    p.runCommandAsync("tickingarea remove goalBlue")
    p.runCommandAsync("tickingarea remove goalYellow")
    p.runCommandAsync("tickingarea remove goalGreen")
    p.runCommandAsync("tag @a remove uncRed")
    p.runCommandAsync("tag @a remove uncBlue")
    p.runCommandAsync("tag @a remove uncYellow")
    p.runCommandAsync("tag @a remove uncGreen")
    var players = Array.from(world.getPlayers())
    signalBlue = false, signalGreen = false, signalRed = false, signalYellow = false
    for(var i = 0; i < players.length; i++){
        if(players[i].hasTag("uncRed")){
            goal_x_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_red = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_red + " 0 " + goal_z_red + " " + goal_x_red + " 0 " + goal_z_red + " goalRed true")
            signalRed = true
        }
        if(players[i].hasTag("uncBlue")){
            goal_x_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_blue = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_blue + " 0 " + goal_z_blue + " " + goal_x_blue + " 0 " + goal_z_blue + " goalBlue true")
            signalBlue = true
        }
        if(players[i].hasTag("uncYellow")){
            goal_x_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_yellow = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_yellow + " 0 " + goal_z_yellow + " " + goal_x_yellow + " 0 " + goal_z_yellow + " goalYellow true")
            signalYellow = true
        }
        if(players[i].hasTag("uncGreen")){
            goal_x_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            goal_z_green = Math.floor(Math.random() * MAX_RANGE - MAX_RANGE / 2)
            p.runCommandAsync("tickingarea add " + goal_x_green + " 0 " + goal_z_green + " " + goal_x_green + " 0 " + goal_z_green + " goalGreen true")
            signalGreen = true
        }
    }
    if(signalBlue == false && signalGreen == false && signalRed == false && signalYellow == false){
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bAll teams have confirmed spawnpoint, game will start in 10s\"}]}")
        p.runCommandAsync("scoreboard players set \"Countdown\" countdown 10")
        p.runCommandAsync("tag @a remove jcz")
        delay8 = system.runSchedule(gameStartFin, 200)
    }
    else{
        p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§bReselecting spawnpoints for some teams, it won't take long.\"}]}")
        delay8 = system.runSchedule(gameStart9, 60)
    }
}
var delay9
function gameStart9(){
    system.clearRunSchedule(delay8)
    p.runCommandAsync("tag @a remove confirmed")
    p.runCommandAsync("tag @a remove confirmed2")
    p.runCommandAsync("tag @a remove uncRed")
    p.runCommandAsync("tag @a remove uncBlue")
    p.runCommandAsync("tag @a remove uncYellow")
    p.runCommandAsync("tag @a remove uncGreen")
    if(signalBlue == true){
        p.runCommandAsync("tp @a[tag=blue] " + goal_x_blue + " 256 " + goal_z_blue)
        p.runCommandAsync("scoreboard players set @a[tag=blue] frost 150")
    }
    if(signalRed == true){
        p.runCommandAsync("tp @a[tag=red] " + goal_x_red + " 256 " + goal_z_red)
        p.runCommandAsync("scoreboard players set @a[tag=red] frost 150")
    }
    if(signalYellow == true){
        p.runCommandAsync("tp @a[tag=yellow] " + goal_x_yellow + " 256 " + goal_z_yellow)
        p.runCommandAsync("scoreboard players set @a[tag=yellow] frost 150")
    }
    if(signalGreen == true){
        p.runCommandAsync("tp @a[tag=green] " + goal_x_green + " 256 " + goal_z_green)
        p.runCommandAsync("scoreboard players set @a[tag=green] frost 150")
    }
    p.runCommandAsync("scoreboard players set @a[tag=preplaying] setborder 60")
    p.runCommandAsync("tellraw @a { \"rawtext\" : [ { \"text\" : \"§aChoices ran out. Game will start in 20s.\"}]}")
    p.runCommandAsync("scoreboard players set \"Countdown\" countdown 20")
    p.runCommandAsync("tag @a remove jcz")
    delay9 = system.runSchedule(gameStartFin, 400)
}
function gameStartFin(){
    if(delay4 != undefined) system.clearRunSchedule(delay4)
    if(delay6 != undefined) system.clearRunSchedule(delay6)
    if(delay8 != undefined) system.clearRunSchedule(delay8)
    if(delay9 != undefined) system.clearRunSchedule(delay9)
    delay1 = undefined
    delay2 = undefined
    delay3 = undefined
    delay4 = undefined
    delay5 = undefined
    delay6 = undefined
    delay7 = undefined
    delay8 = undefined
    delay9 = undefined
    p.runCommandAsync("function start")
}

function printScore(){
    p.runCommandAsync("function score")
    var players = Array.from(world.getPlayers())
    var playerName
    for(var i = 0; i < players.length; i++){
            if(players[i].hasTag("playing") && players[i].hasTag("red")){
                playerName = players[i].name
                players[i].runCommandAsync("scoreboard players operation \"§4" + playerName + "\" scorea = @s score")
            }
            if(players[i].hasTag("playing") && players[i].hasTag("blue")){
                playerName = players[i].name
                players[i].runCommandAsync("scoreboard players operation \"§b" + playerName + "\" scorea = @s score")
            }
            if(players[i].hasTag("playing") && players[i].hasTag("yellow")){
                playerName = players[i].name
                players[i].runCommandAsync("scoreboard players operation \"§e" + playerName + "\" scorea = @s score")
            }
            if(players[i].hasTag("playing") && players[i].hasTag("green")){
                playerName = players[i].name
                players[i].runCommandAsync("scoreboard players operation \"§a" + playerName + "\" scorea = @s score")
            }
    }
}
var toolMans = new Array()
function ticker(){
    mapUsedCount = 0
    printScore()
    var players = Array.from(world.getPlayers())
    for(var i = 0; i < players.length; i++){
        if(!players[i].hasTag("tool")){
            if(players[i].dimension.id == "minecraft:overworld") players[i].runCommandAsync("scoreboard players set @s dimension 0")
            else if(players[i].dimension.id == "minecraft:nether") players[i].runCommandAsync("scoreboard players set @s dimension 1")
            else if(players[i].dimension.id == "minecraft:the_end") players[i].runCommandAsync("scoreboard players set @s dimension 2")
        }
    }
    p.runCommandAsync("tag @a[m=spectator] add spec")
    p.runCommandAsync("tag @a[m=!spectator] remove spec")
}
world.events.explosion.subscribe(t=>{
    if(t.source.typeId == "minecraft:ender_crystal"){
        if(t.source.location.y < 1500) system.run(ticker)
        else system.run(gameStart1)
    }
})

var tickWaitTimes = 20*60*60*24*365
{
    GameTest.register("Bingo", "update", (test) => { {
        var toolMan = test.spawnSimulatedPlayer(new BlockLocation(256,1,0), "BingoBot")
        toolMan.addTag("tool")
    } })
    .maxTicks(tickWaitTimes)
          // .maxTicks(2)
          // .maxAttempts(tickWaitTimes)
          // .requiredSuccessfulAttempts(tickWaitTimes)
          // .padding(0)
    .structureName("mystructure:book")
}